#lang scheme

(provide (struct-out class-decl)
         (struct-out field-decl)
         (struct-out method-decl)
         
         (struct-out lit-expr)
         (struct-out and-expr)
         (struct-out or-expr)
         (struct-out vget-expr)
         (struct-out vset-expr)
         (struct-out cond-expr)
         (struct-out let-expr)
         (struct-out while-expr)
         (struct-out prim-app-expr)
         (struct-out new-expr)
         (struct-out fget-expr)
         (struct-out fset-expr)
         (struct-out send-expr)
         (struct-out super-expr)
         
         (struct-out thread-expr)
         (struct-out wait-expr)
         (struct-out notify-expr)
         
         (struct-out dyn-aspect)
         (struct-out deploy-expr)
         (struct-out deploy-on-expr)
         
         ;runtime
         
         (struct-out rt-class)
         (struct-out rt-object)
         (struct-out rt-method)
         (struct-out rt-field)
         
         (struct-out dasp)
         (struct-out jp))

; Parsing

; structures
(define-struct class-decl  (name sname fields methods))
(define-struct field-decl  (name))
(define-struct method-decl (name params body sync))

(define-struct lit-expr      (value)) ;; number/string/boolean/list
(define-struct and-expr      (args))
(define-struct or-expr       (args))
(define-struct vget-expr     (name))
(define-struct vset-expr     (name value))
(define-struct cond-expr     (branches))
(define-struct let-expr      (names values body))
(define-struct while-expr    (cond body))
(define-struct prim-app-expr (fun args))

; oo
(define-struct new-expr   (class args))
(define-struct fget-expr  (name))
(define-struct fset-expr  (name value))
(define-struct send-expr  (target name args))
(define-struct super-expr (name args))

; concurrency
(define-struct thread-expr (target))
(define-struct wait-expr (cond-name))
(define-struct notify-expr (cond-name))

; deployment
(define-struct dyn-aspect (c d f aspect))
(define-struct deploy-expr (dyn-aspects body))
(define-struct deploy-on-expr (dyn-aspects body))

; ----------------------------------------------------------------------------

; Runtime

(define-struct rt-class  (name (super #:mutable) (fields #:mutable) (methods #:mutable)))
(define-struct rt-field  (class name))
(define-struct rt-method (class name params body sync))
(define-struct rt-object (class fvalues monitor (aspects #:mutable)))

; deployed aspects 
(define-struct dasp (c d f aspect))

(define-struct jp   (kind name target args parent))