#lang scheme

(require "interpreter.scm")

; hello world
(run '((class Main Object
         (method main () 
                 (printf "Hello world!~n"))))
     )

; cond
(run '((class Main Object
         (method main ()
                 (cond 
                   ((= 1 2) (error "1"))
                   ((= 2 1) (error "2"))
                   (else "dummy"))
                 )))
     )

(run '((class Main Object
         (method main ()
                 (if (= 1 2) 
                     (error "1")
                     "dummy")
                 )))
     )
; while

(run '((class Main Object
         (method main () 
                 (if (= (send this test) 0)
                     "ok!"
                     (error "while")))
         (method test ()
                 (let ((n 3))
                   (while (> n 0)
                          (printf "~a~n" n)
                          (set! n (- n 1))
                          n))))))


; super call
(run '((class Main Object
         (method main () 
                 (send (new B) test))
         )
       (class A Object
         (method m ()
                 "dummy"))
       (class B A 
         (method m ()
                 (error "This should not be executed"))
         (method test ()
                 (super m))
         )
       ))

; field values
(run '((class Main Object
         (method main () 
                 (send (new A) test))
         )
       (class A Object 
         (field f)
         (method init ()
                 (fset! f 1))
         (method test ()
                 (if (not (equal? (fget f) 1))
                     (error "Field not being set!")
                     "dummy"))
         )
       ))

; shadowing 
(run '((class Main Object
         (method main () 
                 (send (new B) test))
         )
       (class A Object 
         (field f)
         (method init ()
                 (fset! f "a"))
         (method get-f ()
                 (fget f))
         )
       (class B A
         (field f)
         (method init ()
                 (super init)
                 (fset! f "b"))
         (method test ()
                 (if (or (not (equal? (fget f) "b"))
                         (not (equal? (send this get-f) "a")))
                     (error "Shadowing")
                     "dummy"))
         )
       ))

; odd/even
(run '((class Main Object
         (method main () 
                 (send (new OddEven) test))
         )
       (class OddEven Object 
         (method even (n)
                 (if (= n 0)
                     #t
                     (send this odd (- n 1))))
         (method odd (n)
                 (if (= n 0)
                     #f
                     (send this even (- n 1))))
         (method test ()
                 (if (send this even 13)
                     (error "odd/even (1)")
                     "dummy")
                 (if (send this odd 20)
                     (error "odd/even (2)")
                     "dummy"))
          )
       ))

; thread

; deploy
(run '((class Main Object
         (method main () 
                 (deploy ((#f #t #t (new Asp)))
                         (send this test)))
         (method test ()
                 (send this x)
                 (send this y))
         (method x ()
                 (printf "x()~n"))
         (method y ()
                 (printf "y()~n"))
         )
       (class Asp Object 
         (method pc(jp)
                 #t)
         (method advice (jp)
                 (printf "advice!~n"))
         )
       ))